<?php

/**
 * Security Group Object
 */

class UIESecGroup extends UIEBaseModel {
  protected $table_name = '{f_groups}';

  protected $group_id;
  protected $group_name;
  protected $group_short_name;

  public function __construct() {
  }

  public function Validate() {
    $this->validated = false;
    $validate_mode = $this->GetMode();
    switch ($validate_mode) {
      case UIEMODEL_MODE_ADD:
        if(!$this->group_name) { $this->AddError('Name not set'); }
        if(!$this->group_short_name) { $this->AddError('Shortname not set'); }
      break;
      case UIEMODEL_MODE_UPDATE:
        if(!$this->group_id) { $this->AddError('Group Id not set'); }
        if(!$this->group_name) { $this->AddError('Name not set'); }
        if(!$this->group_short_name) { $this->AddError('ShortName not set'); }
      break;
      case UIEMODEL_MODE_DELETE:
        if(!$this->group_id) { $this->AddError('Group Id not set'); }
      break;
      default:
        $this->AddError('Unknown mode: '.$validate_mode);
      break;
    }
    if($this->NoErrors()) {
      $this->validated = true;
    }
  }

  public function Maintain() {
    if(!$this->IsValidated()) {
      $this->AddError('Not validated');
      return false;
    }

    $success = false;
    $maintain_mode = $this->GetMode();
    switch ($GLOBALS['db_type']) {
      case 'mysql':
      case 'mysqli':
        switch ($maintain_mode) {
          case UIEMODEL_MODE_ADD:
            $success = db_query("INSERT INTO {$this->GetTableName()} (GroupName, GroupShortName) VALUES ('%s', '%s')", $this->GetName(), $this->GetShortName());
            if($success) {
              $query = db_query("SELECT LAST_INSERT_ID() AS id");
              $result = db_fetch_object($query);
              $this->SetGroupId($result->id);
            }
            break;
          case UIEMODEL_MODE_UPDATE:
            $success = db_query("UPDATE {$this->GetTableName()} SET GroupName='%s', GroupShortName='%s' WHERE GroupID=%d", $this->GetName(), $this->GetShortName(), $this->GetGroupId());
            break;
          case UIEMODEL_MODE_DELETE:
            $success = db_query("DELETE FROM {$this->GetTableName()} WHERE GroupID=%d", $this->GetGroupId());
            break;
        }
        break;
    }
    return $success ? true : false;
  }

  public function Search() {
    if(!$this->IsValidated()) {
      $this->AddError('Not validated');
      return false;
    }

    $vTempResults = db_query("SELECT GroupShortName FROM {$this->GetTableName()} WHERE GroupID = %d AND GroupName = %d", $this->GetGroupId(), $this->GetName());
    return $vTempResults;
  }

  public function GetGroupId() { return $this->group_id; }
  public function GetName() { return $this->group_name; }
  public function GetShortName() { return $this->group_short_name; }

  public function SetGroupId($group_id) {
    $this->group_id = $group_id;
  }

  public function SetName($group_name) {
    $this->group_name = $group_name;
  }

  public function SetShortName($group_short_name) {
    $this->group_short_name = $group_short_name;
  }

  public function GetById($pId) {
    $this->SetGroupId($pId);
    $vObj = db_fetch_object(db_query("SELECT * FROM {$this->GetTableName()} WHERE GroupID=%d", $this->GetGroupId()));
    if(!$vObj) {
      $this->SetGroupId(null);
      return false;
    }
    $this->SetName($vObj->GroupName);
    $this->SetShortName($vObj->GroupShortName);

    return true;
  }

  public function GetArrayValues() {
    return array(
      'GroupID' => $this->GetGroupId()
      , 'GroupName' => $this->GetName()
      , 'GroupShortName' => $this->GetShortName()
    );
  }
}
