<?php

/**
 * Security Group Access Object
 */

class UIESecGroupAccess extends UIEBaseModel {
  protected $table_name = '{f_groups_access}';

  protected $group_access_id;
  protected $group_id;
  protected $forum_id;

  public function __construct() {
  }

  public function Validate() {
    $this->validated = false;
    $validate_mode = $this->GetMode();
    switch ($validate_mode) {
      case UIEMODEL_MODE_ADD:
        if(!$this->group_id) { $this->AddError('Group Id not set'); }
        if(!$this->forum_id) { $this->AddError('Forum Id not set'); }
      break;
      case UIEMODEL_MODE_UPDATE:
        if(!$this->group_access_id) { $this->AddError('Group Access Id not set'); }
        if(!$this->group_id) { $this->AddError('Group Id not set'); }
        if(!$this->forum_id) { $this->AddError('Forum Id not set'); }
      break;
      case UIEMODEL_MODE_DELETE:
        if(!$this->forum_id) { $this->AddError('Forum Id not set'); }
      break;
      default:
        $this->AddError('Unknown mode: '.$validate_mode);
      break;
    }
    if($this->NoErrors()) {
      $this->validated = true;
    }
  }

  public function Maintain() {
    if(!$this->IsValidated()) {
      $this->AddError('Not validated');
      return false;
    }

    $success = false;
    $maintain_mode = $this->GetMode();
    switch ($GLOBALS['db_type']) {
      case 'mysql':
      case 'mysqli':
        switch ($maintain_mode) {
          case UIEMODEL_MODE_ADD:
            $success = db_query("REPLACE INTO {$this->GetTableName()} SET ForumID='%d', GroupID='%d'", $this->GetForumId(), $this->GetGroupId());
            break;
          case UIEMODEL_MODE_DELETE:
            $success = db_query("DELETE FROM {$this->GetTableName()} WHERE ForumID=%d", $this->GetForumId());
            break;
        }
        break;
    }
    return $success ? true : false;
  }

/*  public function Search() {
    if(!$this->IsValidated()) {
      $this->AddError('Not validated');
      return false;
    }

    $vTempResults = db_query("SELECT GroupShortName FROM {$this->GetTableName()} WHERE GroupID = %d AND GroupName = %d", $this->GetUid(), $this->GetTid());
    return $vTempResults;
  }*/

  public function GetGroupAccessId() { return $this->group_access_id; }
  public function GetGroupId() { return $this->group_id; }
  public function GetForumId() { return $this->forum_id; }

  public function SetGroupAccessId($group_access_id) {
    $this->group_access_id = $group_access_id;
  }

  public function SetGroupId($group_id) {
    $this->group_id = $group_id;
  }

  public function SetForumId($pFid) {
    $this->forum_id = $pFid;
  }

  public function GetById($pId) {
    $this->SetGroupAccessId($pId);
    $vObj = db_fetch_object(db_query("SELECT * FROM {$this->GetTableName()} WHERE GroupAccessID=%d", $this->GetGroupAccessId()));
    $this->SetGroupId($vObj->GroupID);
    $this->SetForumId($vObj->ForumID);
  }

/*  public function GetArrayValues() {
    return array(
      'GroupAccessID' => $this->GetGroupAccessId()
      , 'GroupID' => $this->GetGroupId()
      , 'ForumID' => $this->GetForumId()
    );
  }*/
}
