<?php

class UIEBaseModel {
  protected $mode;
  protected $validated = false;
  protected $error_counter = 0;
  protected $errors = false;
  protected $table_name;

/*
  public function __call($pMethod, $pArgs)
  {
    $vGetSet = strtolower(substr($pMethod, 0, 3));
    $vVarName = 'm'.substr($pMethod, 3);
    switch($vGetSet) {
      case 'get':
        return $this->{$vVarName};
        break;
      case 'set':
        $vValue = array_pop($pArgs);
        $this->{$vVarName} = $vValue;
        break;
    }
  }
*/
  public function GetById() { $this->AddError('No GetById Function defined'); }
  public function GetArrayValues() { $this->AddError('No GetArrayValues Function defined'); }
  public function Maintain() { $this->AddError('No Maintain Function defined'); }
  public function Validate() { $this->AddError('No Validate Function defined'); }
  public function Search() { $this->AddError('No Search Function defined'); }
  public function InitFromResults($pResultObj) { $this->AddError('No InitFromResults Function defined'); }

  public function GetMode() {
    return $this->mode;
  }

  public function SetMode($mode) {
    $this->mode = $mode;
  }

  public function NoErrors() {
    return $this->error_counter == 0;
  }

  public function GetErrors() {
    return $this->errors;
  }

  public function AddError($pError) {
    if(!$this->errors) {
      $this->errors = true;
    }
    $vThisClass = get_class($this);
    form_set_error($vThisClass . $this->error_counter++, $vThisClass . ' - ' . t($pError));
  }

  public function GetTableName() {
    return $this->table_name;
  }

  public function IsValidated() {
    return $this->validated;
  }
}
